<?php
namespace Teknisa\FIN\Controllers;

use Teknisa\Libs\Service\CRUD as CrudService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Libs\Util\Environment;
use Teknisa\FIN\Controllers\TeknisaCrud;
use Teknisa\FIN\Services\importacaoBancariaService;

/**
 * Class ImportacaoBancariaController
 * @package Teknisa\FIN\Controllers
 */
class ImportacaoBancariaController extends TeknisaCrud{
    
    protected $crudService;
    protected $parameterBag;
    protected $environment;
	protected $importacaoBancariaService;
    
    /**
     * @param CrudService  $crudService
     * @param ParameterBag $parameterBag
     * @param Environment  $environment
     * @param ImportacaoBancariaService $importacaoBancariaService
     */
    public function __construct(CrudService $crudService, ParameterBag $parameterBag, Environment $environment, ImportacaoBancariaService $importacaoBancariaService){
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->importacaoBancariaService  = $importacaoBancariaService;
    }
    
    /**
     * Importação de dados bancarios importados via método SOAP
     */
    public function importaDadosBancarios(){
        try{
            $this->importacaoBancariaService->importaDadosBancarios();
        }catch(\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    /**
     * Importação de dados bancarios importados via método SOAP
     */
    public function exportaDadosBancarios(){
        try{
            $this->importacaoBancariaService->exportaDadosBancarios();
        }catch(\Exception $e) {
            echo($e->getMessage());
        }
    }
    
    /**
     * Importação de dados bancarios importados via Client
     */
    public function importaDadosBancariosClient(){
        try{
            $this->importacaoBancariaService->importaDadosBancariosClient();
        }catch(\Exception $e) {
            echo($e->getMessage());
        }
    }
    
}