package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.UsuariosDBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.TitulosAPagarPage;
import org.testng.annotations.Test;

public class TitulosAPagarTests extends TestBase {

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    TitulosAPagarPage titulosAPagarPage;

    @Test
    public void efetuarLancamentoTituloPagar() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAPagarPage = new TitulosAPagarPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";

        String FornecedorTitulosPagar = "Leandro Henrique Ferreira";
        String nrDocumento = "54321";
        String vrTituloPagar = "555";
        String dtVencimento = "01012050";

        //Efetuarlogin
        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosPagar();

        //Confirmar Filtro
        titulosAPagarPage.clicarAplicarFiltro();

        //Clicar em adicionar Título
        titulosAPagarPage.clicarAdicionarTituloPagar();

        //Inserir informações para inserir Título
        titulosAPagarPage.limparUnidadeOrigem();
        titulosAPagarPage.procurarUnidadeOrigem();
        titulosAPagarPage.selecionarUnidadeOrigem();
        titulosAPagarPage.preencherFornecedorTituloPagar(FornecedorTitulosPagar);
        titulosAPagarPage.selecionarFornecedorTituloPagar();
        titulosAPagarPage.preencherTipoOperacaoTituloPagar();
        titulosAPagarPage.selecionarTipoOperacaoTituloPagar();
        titulosAPagarPage.preencherNrDocumentoTituloPagar(nrDocumento);
        titulosAPagarPage.preencherSerieTituloPagar();
        titulosAPagarPage.selecionarSerieTituloPagar();
        titulosAPagarPage.preencherValorTituloPagar(vrTituloPagar);
        titulosAPagarPage.preencherTipoContaTituloPagar();
        titulosAPagarPage.selecionarTipoContaTiluloPagar();
        titulosAPagarPage.clicarVencimentoTituloPagar();
        titulosAPagarPage.preencherVencimentoTituloPagar(dtVencimento);
        titulosAPagarPage.clicarSalvarTituloPagar();
        titulosAPagarPage.clicarSalvarAlteracoesTituloPagar();
        titulosAPagarPage.clicarSalvarTituloPagar();
        titulosAPagarPage.clicarOkTitulosPagar();

    }


    @Test
    public void ajustetituloPagar() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAPagarPage = new TitulosAPagarPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";

        String nfInicial = "000054321";
        String nfFinal = "000054321";
        String valorAjuste = "50";

        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosPagar();

        //Preencher Filtro
        titulosAPagarPage.preencherNFFiltro(nfInicial, nfFinal);

        //Alterar Titulo
        titulosAPagarPage.selecionarTituloPagarAlterar();

        //Inserir e excluir ajustes
        titulosAPagarPage.clicarAbaAjusteTituloPagar();
        titulosAPagarPage.incluirExcluirAjusteTituloPagar(valorAjuste);


    }

    @Test
    public void baixaTituloPagar() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAPagarPage = new TitulosAPagarPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";

        String nfInicial = "000054321";
        String nfFinal = "000054321";
        String observacaoBaixa = "Baixa Automatizada";

        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosPagar();

        //Preencher Filtro
        titulosAPagarPage.preencherNFFiltro(nfInicial, nfFinal);

        //Realizar baixa de Titulo
        titulosAPagarPage.baixarTituloPagar(observacaoBaixa);

    }

    @Test
    public void prorrogaTituloPagar() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAPagarPage = new TitulosAPagarPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";

        String nfInicial = "000054321";
        String nfFinal = "000054321";
        String dtVencimento = "02012050";

        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosPagar();

        //Preencher Filtro
        titulosAPagarPage.preencherNFFiltro(nfInicial, nfFinal);
        titulosAPagarPage.prorrogarTituloPagar(dtVencimento);
    }

    @Test
    public void anteciparTituloPagar() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAPagarPage = new TitulosAPagarPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";

        String nfInicial = "000054321";
        String nfFinal = "000054321";
        String dtVencimento = "01012050";
        String dtEmissao = "01012050";
        String descAntecipar = "Antecipação Automação";
        String FornecedorTitulosPagar = "Leandro Henrique Ferreira";

        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosPagar();

        //Preencher Filtro
        titulosAPagarPage.preencherNFFiltro(nfInicial, nfFinal);
        titulosAPagarPage.anteciparTituloPagar(dtVencimento, dtEmissao, descAntecipar, FornecedorTitulosPagar);

    }

    @Test
    public void cadastramentoAutomatico() {
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        titulosAPagarPage = new TitulosAPagarPage();

        //Parametros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";
        String valorTituloCadAut = "1000";

        String FornecedorTitulosPagar = "Leandro Henrique Ferreira";

        loginFlows.efetuarLogin(usuario, senha);
        mainFlows.navegarParaTitulosPagar();

        titulosAPagarPage.clicarAplicarFiltro();
        titulosAPagarPage.cadastramentoAutomatico(FornecedorTitulosPagar,valorTituloCadAut);
    }
}